package  
{
	import flash.geom.Rectangle;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.masks.Hitbox;
	import net.flashpunk.Sfx;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.World;
	/**
	 * ...
	 * @author Wade McGillis
	 */
	public class Beeferton extends Entity
	{
		private var flashing:Boolean;
		private var hurtTimer:int;
		private var flashTimer:int;
		private var detectLast:Boolean;
		public function Beeferton(xx:Number, yy:Number ) 
		{
			x = xx;
			y = yy;
			graphic = new Image(Resource.cow);
			setHitbox(48, 48);
			type = "beeferton";
			flashTimer = 0;
			hurtTimer = 0;
			layer = -100;
			detectLast = false;
		}
		
		private function tryToMove(xx:Number, yy:Number):void
		{
			var h:HorzDoor;
			h = collide("horzdoor", xx, yy) as HorzDoor;
			if (h)
			{
				if (Game.keys[h.mycolor] > 0)
				{
					if (h.mycolor == 0)
						Game.keys[h.mycolor]--;
					FP.world.remove(h);
				}
			}
			var v:VertDoor;
			v = collide("vertdoor", xx, yy) as VertDoor;
			if (v)
			{
				if (Game.keys[v.mycolor] > 0)
				{
					if (v.mycolor == 0)
						Game.keys[v.mycolor]--;
					FP.world.remove(v);
				}
			}
			if (!collideTerrain(xx,yy))
			{
				x = xx;
				y = yy;
			}
		}
		
		override public function update():void
		{
			super.update();
			if (Input.check(Game.KEY_MOVEUP))
				tryToMove(x, y - 8);
			if (Input.check(Game.KEY_MOVELEFT))
				tryToMove(x - 8, y);
			if (Input.check(Game.KEY_MOVEDOWN))
				tryToMove(x, y+ 8);
			if (Input.check(Game.KEY_MOVERIGHT))
				tryToMove(x+8, y);
					
			var e:Entity;
			e = collide("stairsdown", x, y);
			if (e && Input.pressed(Game.KEY_MOVEACTION))
			{
				Game.goDownStairs();
				new Sfx(Resource.snd_downstairs).play(Game.soundOn?1:0);
				return;
			}
			e = collide("stairsup", x, y);
			if (e && Input.pressed(Game.KEY_MOVEACTION))
			{
				Game.goUpStairs();
				new Sfx(Resource.snd_upstairs).play(Game.soundOn?1:0);
				return;
			}
				
			if (Game.hasLaserGun)
			{
				if (Input.mousePressed)
				{
					trace("SHOOT");
					FP.world.add(new LaserBeam(x + 24, y + 24, FP.angle(x + 24, y + 24, FP.camera.x + Input.mouseX, FP.camera.y + Input.mouseY)));
				}
			}
					
			var l:LaserGun = collide("lasergun", x, y) as LaserGun;
			if (l)
			{
				new Sfx(Resource.snd_gun).play(Game.soundOn?1:0);
				FP.world.remove(l);
				Game.hasLaserGun = true;
			}
			
			if (collide("blueenemy", x, y))
				hurtMe(1);
				
			if (collide("redenemy", x, y))
				hurtMe(1);
				
			var e:Entity = collide("redenemybullet", x, y);
			if (e)
			{
				FP.world.remove(e);
				hurtMe(1);
			}
				
			e = collide("bone", x, y);
			if (e)
			{
				FP.world.remove(e);
				hurtMe(2);
			}
				
			if (collide("ghost", x, y))
				hurtMe(2);
				
			if (collide("hl3", x, y))
			{
				Game.backgroundMusic.stop();
				Game.bossMusic.stop();
				Game.finalBossMusic.stop();
				FP.world = new Credits();
			}
				
			if (collide("detector",x,y))
			{
				if (detectLast == false)
				{
					Game.backgroundMusic.stop();
					Game.explanation.play();
				}
				detectLast = true;
			}
			else
			{
				if (detectLast)
				{
					Game.explanation.stop();
					Game.backgroundMusic.loop(Game.soundOn?1:0);
				}
				detectLast = false;
			}
			
			
			
			var k:GoldenKey = collide("key", x, y) as GoldenKey;
			if (k)
			{
				new Sfx(Resource.snd_key).play(Game.soundOn?1:0);
				FP.world.remove(k);
				Game.keys[k.mycolor]++;
			}
			
			var h:HeartPickup = collide("heartpickup", x, y) as HeartPickup;
			if (h)
			{
				new Sfx(Resource.snd_heart).play(Game.soundOn?1:0);
				FP.world.remove(h);
				Game.maxhp += 6;
				Game.hp += 6;
			}
			
			if (hurtTimer > 0)
			{
				if (flashTimer > 0)
					flashTimer--;
				if (flashTimer == 0)
				{
					flashing = !flashing;
					flashTimer = 10;
				}
				hurtTimer--;
			}
			
			(graphic as Image).tinting = flashing?1:0;
		}
		
		override public function render():void
		{
			super.render();
			/*var w:GameWorld = FP.world as GameWorld;
			var tx:int = x / 48;
			var ty:int = y / 48;
			for (var i:int = -2; i <= 2; i++)
				for (var j:int = -2; j <= 2; j++)
				{
					if (w.checkGrid(tx + i, ty + j))
					{
						if (flashpunkHasCrapCollisions(x, y, 48 * (tx + i), 48 * (ty + j), 48, 48))
							Draw.rect(48 * (tx + i), 48 * (ty + j), 48, 48, 0xFF0000, .5);
						else
							Draw.rect(48 * (tx + i), 48 * (ty + j), 48, 48, 0x00FF00, .5);
					}
				}*/
		}
		
		private function hurtMe(i:int):void
		{
			if (hurtTimer == 0)
			{
				hurtTimer = 60;
				flashTimer = 0;
				Game.hp -= i;
				if (Game.hp <= 0)
				{
					var o:OhCrapYouDied = new OhCrapYouDied();
					o.beefX = x - FP.camera.x + 24;
					o.beefY = y - FP.camera.y + 24 + Game.HUDHEIGHT;
					FP.world = o;
				}
			}
		}
		
		private function collideTerrain(xx:Number, yy:Number):Boolean
		{
			var w:GameLevel = FP.world as GameLevel;
			var tx:int = xx / 48;
			var ty:int = yy / 48;
			for (var i:int = -2; i <= 2; i++)
				for (var j:int = -2; j <= 2; j++)
				{
					if (w.getGrid(tx + i, ty + j))
					{
						if (flashpunkHasCrapCollisions(xx, yy, 48 * (tx + i), 48 * (ty + j), 48, 48))
							return true;
					}
				}
			return false;
		}
		
		private function flashpunkHasCrapCollisions(xx:Number, yy:Number, ox:Number, oy:Number, ww:Number, hh:Number):Boolean
		{
			var r1:Rectangle = new Rectangle(xx, yy, width, height);
			var r2:Rectangle = new Rectangle(ox, oy, ww, hh);
			return r1.intersects(r2);
		}
		
	}

}