package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Input;
	/**
	 * ...
	 * @author Wade McGillis
	 */
	public class Button extends Entity
	{
		
		private var color:uint;
		private var text:String;
		private var hover:Boolean;
		private var textcolor:uint;
		private var doMyFunction:Function;
		private var forced:Boolean;
		
		public function Button(func:Function,xx:Number,yy:Number,str:String,col:uint,texcol:uint) 
		{
			x = xx;
			y = yy;
			text = str;
			width = 24 * (text.length + 2);
			height = 64;
			x -= width / 2;
			y -= height / 2;
			color = col;
			hover = false;
			textcolor = texcol;
			doMyFunction = func;
			forced = false;
		}
		
		public function setForced(b:Boolean):void
		{
			forced = b;
		}
		
		override public function update():void
		{
			hover = (Input.mouseX >= x - 3 && Input.mouseX <= x + width + 3 && Input.mouseY >= y - 3 && Input.mouseY <= y + height + 3) || forced;
			if (Input.mousePressed && hover)
				doMyFunction();
		}
		
		override public function render():void
		{
			super.render();
			Draw.rect(x-3, y-3, width+6, height+6, 0x000000);
			Draw.rect(x, y, width, height, FP.colorLerp(color,0xFFFFFF,.5*(hover?1:0)));
			Game.draw_text(false, text, x + width/2 - 24*text.length/2, y + 8, textcolor);			
		}
		
	}

}