package  
{
	import flash.utils.ByteArray;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.graphics.TiledImage;
	import net.flashpunk.masks.Grid;
	import net.flashpunk.Sfx;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.World;
	/**
	 * ...
	 * @author Wade McGillis
	 */
	public class Game 
	{
		public static const HUDHEIGHT:int = 96;
		
		public static var KEY_MOVEUP:int = Key.W;
		public static var KEY_MOVELEFT:int = Key.A;
		public static var KEY_MOVEDOWN:int = Key.S;
		public static var KEY_MOVERIGHT:int = Key.D;
		
		
		public static var KEY_MOVEACTION:int = Key.SPACE;
		
		public static var redkey:Image;
		public static var greenkey:Image;
		public static var bluekey:Image;
		public static var key:Image;
		
		public static var hud_talking:Image;
		public static var hud_normal:Image;
		public static var hud_logo:Image;
		public static var hud_totem:Image;
		
		public static var hud_heart_empty:Image;
		public static var hud_heart_half:Image;
		public static var hud_heart_full:Image;
		
		
		public static var floor_rock:TiledImage;
		public static var floor_grass:TiledImage;
		public static var floor_wood:TiledImage;
		
		public static var reticle:Image;
		
		public static var hp:int;
		public static var maxhp:int;
		
		public static var hasLaserGun:Boolean;
		public static var keys:Array;
		
		private static var worlds:Array = [];
		
		private static var currentLevel:int;
		
		public static var beefX:Number;
		public static var beefY:Number;
		
		private static var font:Spritemap;
		private static var alienfont:Spritemap;
		
		public static var backgroundMusic:Sfx;
		public static var loseMusic:Sfx;
		public static var bossMusic:Sfx;
		public static var finalBossMusic:Sfx;
		public static var explanation:Sfx;
		public static var creditsMusic:Sfx;
		
		public static var sounds:Array;
		
		public static var soundOn:Boolean;
		
		private static function c(s:String):int
		{
			return s.charCodeAt(0) as int;
		}
		
		private static function fix(str:String):String
		{
			// SUPER BORKY. DO NOT USE IN YOUR OWN PROJECTS. PLEASE. IT FAILS HARD IF YOU USE SUPER LONG WORDS.
			var lastnew:int = 0;
			var lastspace:int = 0;
			for (var i:int = 0; i < str.length; i++)
			{
				if (str.charAt(i) == "\n")
				{
					lastspace = i;
					lastnew = i;
				}
				if (str.charAt(i) == " ")
					lastspace = i;
				if (i-lastnew >= 30)
				{
					///var pp:int = ;
					if (i-lastspace < 30)
					{
						//str[pp] = "x";
						var str2:String = "";
						trace(" FIRST: "+str.substr(0, lastspace));
						trace("SECOND: "+str.substr(lastspace + 1, str.length - (lastspace + 1)));
						str2 = str2.concat(str.substr(0, lastspace));
						str2 = str2.concat("\n");
						str2 = str2.concat(str.substr(lastspace, str.length - (lastspace)));
						trace("RESULT: "+str2);
						return fix(str2);
						/*trace("Replace: --" + str.substr(0, lastspace+1) + "--");
						trace("With:    --" + str.substr(0, lastspace) + "COLOGNE");
						str.replace(str.substr(0, lastspace), str.substr(0, lastspace-1) + "COLOGNE");
						lastnew = pp;
						trace(str);*/
					}
				}	
			}
			return str;
		}
		
		public static function draw_textPOOP(str:String, x:Number, y:Number, color:uint)
		{
			FP.point.x = x;
			FP.point.y = y;
			var spm:Spritemap;
			spm = font;
			spm.tinting = 1;
			spm.color = color;
			for (var pos:int = 0; pos < str.length; pos++)
			{
				var char:int = str.charCodeAt(pos) as int;
				spm.frame = char - 32;
				spm.render(FP.point, FP.zero);
				FP.point.x += 24;
			}
			
		}
		
		public static function draw_text(encrypted:Boolean, str:String, x:Number, y:Number, color:uint)
		{
			str = str.substr(0, 30 * 3);
			str = fix(str);
			FP.point.x = x;
			FP.point.y = y;
			var spm:Spritemap;
			if (encrypted)
				spm = alienfont;
			else
				spm = font;
			spm.tinting = 1;
			spm.color = color;
			for (var pos:int = 0; pos < str.length; pos++)
			{
				var char:int = str.charCodeAt(pos) as int;
				if (char == c("\n"))
					//if (str.charCodeAt(pos + 1) == c("n"))
					{
						trace("BEEP");
						FP.point.x = x;
						FP.point.y += 48;
						pos++;
						continue;
					}
				if (encrypted)
				{
					var letterdiff = c('a') - c('A');
					if (char >= c('a') && char <= c('z'))
						char -= letterdiff;
				}
				spm.frame = char - 32;
				spm.render(FP.point, FP.zero);
				FP.point.x += 24;
				if (FP.point.x > x + 24 * 30)
				{
					FP.point.x = x;
					FP.point.y += 48;
				}
			}
			
		}
		
		public static function reinitialize():void
		{
			maxhp = 36;
			hp = maxhp;
			hasLaserGun = false;
			while (keys.length > 0)
				keys.pop();
			keys.push(0);
			keys.push(0);
			keys.push(0);
			keys.push(0);
			
			beefX = -5000;
			beefY = -5000;
			while (worlds.length > 0)
				worlds.pop();			
				
			//worlds.push(new GameLevel(new Resource.finalboss_oel));
			//worlds.push(new GameLevel(new Resource.boss_oel));
			
			//worlds.push(new GameLevel(new Resource.test_oel));
			worlds.push(new GameLevel(new Resource.test_oel));
			worlds.push(new GameLevel(new Resource.upper_oel));
			worlds.push(new GameLevel(new Resource.three_oel));
			worlds.push(new GameLevel(new Resource.boss_oel));
			worlds.push(new GameLevel(new Resource.finalboss_oel));
		}
		
		public static function playBullet():int
		{
			for (var i:int = 0; i < sounds.length; i++)
				if (!sounds[i].playing)
				{
					sounds[i].play(Game.soundOn?1:0);
					return i;
				}
			return -1;
		}
	
		public static function stopBullet(id:int):void
		{
			sounds[id].stop();
		}
		
		public static function stopAllBullets():void
		{
			for (var i:int = 0; i < sounds.length; i++)
				sounds[i].stop();
		}
		
		public static function init() 
		{
			soundOn = true;
			sounds = [];
			for (var i:int = 0; i < 15; i++)
				sounds.push(new Sfx(Resource.snd_laser));
			backgroundMusic = new Sfx(Resource.snd_bg);
			loseMusic = new Sfx(Resource.snd_lose);
			bossMusic = new Sfx(Resource.snd_boss);
			finalBossMusic = new Sfx(Resource.snd_finalboss);
			explanation = new Sfx(Resource.snd_explain);
			creditsMusic = new Sfx(Resource.snd_credits);
			keys = [];

			font = new Spritemap(Resource.font, 24, 48);
			alienfont = new Spritemap(Resource.alienfont, 24, 48);
			floor_rock = new TiledImage(Resource.floor_rock, 768, 480);
			floor_grass = new TiledImage(Resource.floor_grass, 768, 480);
			floor_wood = new TiledImage(Resource.floor_wood, 768, 480);
			

			hud_talking = new Image(Resource.hud_talking);
			hud_normal = new Image(Resource.hud_regular);
			hud_logo = new Image(Resource.hud_logo);
			hud_totem = new Image(Resource.hud_totem);
			hud_heart_empty = new Image(Resource.hud_heart_empty);
			hud_heart_half = new Image(Resource.hud_heart_half);
			hud_heart_full = new Image(Resource.hud_heart_full);
			reticle = new Image(Resource.reticle);
			reticle.originX = 23;
			reticle.originY = 23;
			
			redkey = new Image(Resource.key_red);
			redkey.scale = 1;//.75;
			greenkey = new Image(Resource.key_green);
			greenkey.scale = 1;// .75;
			bluekey = new Image(Resource.key_blue);
			bluekey.scale = 1;//.75;
			
			key = new Image(Resource.key);
			key.scale = 1;//.75;
			

		}

		public static function goUpStairs():void
		{
			if (currentLevel+1 < 0 || currentLevel+1 > worlds.length-1)
				return;
			currentLevel++;
			FP.world = worlds[currentLevel];
		}
		
		public static function goDownStairs():void
		{
			if (currentLevel-1 < 0 || currentLevel-1 > worlds.length-1)
				return;
			currentLevel--;
			FP.world = worlds[currentLevel];
		}
		
		public static function switchToLevel(lv:int):void
		{
			if (lv < 0 || lv > worlds.length-1)
				return;
			currentLevel = lv;
			FP.world = worlds[currentLevel];
		}
		
		public static function drawHUD():void
		{
			Game.hud_normal.render(FP.zero, FP.zero);
			Game.hud_logo.render(FP.zero, FP.zero);
			FP.point.x = 176;
			FP.point.y = 8
			var iprev:int = 0;
			for (var i:int = 0; i < Game.maxhp / 2; i++)
			{
				if (i > 17 && iprev <= 17)
				{
					FP.point.y += 40;
					FP.point.x = 176;
				}
				iprev = i;
				if (Game.hp-1 < i * 2)
					Game.hud_heart_empty.render(FP.point, FP.zero);
				else
				{
					if (Game.hp-1 == i*2)
						Game.hud_heart_half.render(FP.point, FP.zero);
					else
						Game.hud_heart_full.render(FP.point, FP.zero);
				}
				FP.point.x += 32;
			}
		FP.point.x = 8;
		FP.point.y = 48;
		if (Game.keys[1] > 0)
			Game.redkey.render(FP.point, FP.zero);
		FP.point.x += 20;
		if (Game.keys[2] > 0)
			Game.greenkey.render(FP.point, FP.zero);
		FP.point.x += 20;
		if (Game.keys[3] > 0)
			Game.bluekey.render(FP.point, FP.zero);
		FP.point.x += 20;
		Game.key.render(FP.point, FP.zero);
		FP.point.x += 40;
		Game.draw_text(false, "x" + Game.keys[0], FP.point.x, FP.point.y-8, 0xFFFFFF);
		}
		
	}

}