package  
{
	import flash.utils.ByteArray;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.TiledImage;
	import net.flashpunk.masks.Grid;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.World;
	/**
	 * ...
	 * @author Wade McGillis
	 */
	public class GameLevel extends World
	{
		private var worldXML:XML;
		private var lastViewX:int;
		private var lastViewY:int;
		
		private var targetViewX:Number;
		private var targetViewY:Number;
		
		public var myBeefy:Beeferton;
		
		private var collisionGrid:Grid;
		
		private var bgGrid:Array;
		
		public function GameLevel(source:*= null):void
		{
			super();
			myBeefy = null;
			lastViewX = -500;
			lastViewY = -500;
			worldXML = new XML(source);
			//trace("W: " + worldXML.@width + " H: " + worldXML.@height);
			collisionGrid = new Grid(worldXML.@width / 48, worldXML.@height / 48,1,1,0,0);
			collisionGrid.setRect(0, 0, worldXML.@width / 48, worldXML.@height / 48, false);
			bgGrid = new Array;
			for (var i:int = 0; i <= worldXML.@width / 768; i++)
			{
				bgGrid.push(new Array);
				for (var j:int = 0; j <= worldXML.@height / 480; j++)
					bgGrid[i].push(new Array);
			}
			if (worldXML.Floors)
			{
				var tile:XML;
				for each(tile in worldXML.Floors.tile)
				{
					if (tile.@ty == 0)
					{
						if (tile.@tx == 0) // rock floor
							bgGrid[tile.@x][tile.@y] = 0;
						if (tile.@tx == 1) // grass floor
							bgGrid[tile.@x][tile.@y] = 1;
					}
					if (tile.@ty == 1)
					{
						if (tile.@tx == 0) // wood floor
							bgGrid[tile.@x][tile.@y] = 2;
					}
				}
			}
			if (worldXML.Entities)
			{
				//trace("hello?");
				var ent:XML;
				for each(ent in worldXML.Entities.Beeferton)
				{
					myBeefy = add(new Beeferton(ent.@x, ent.@y)) as Beeferton;
				}
				for each(ent in worldXML.Entities.LaserGun)
				{
					add(new LaserGun(ent.@x, ent.@y));
				}
				for each(ent in worldXML.Entities.LaserGun)
				{
					add(new LaserGun(ent.@x, ent.@y));
				}
				for each(ent in worldXML.Entities.BlueEnemy)
				{
					add(new BlueEnemy(ent.@x, ent.@y));
				}
				for each(ent in worldXML.Entities.Ghost)
				{
					add(new Ghost(ent.@x, ent.@y));
				}
				for each(ent in worldXML.Entities.Boss)
				{
					add(new Boss(ent.@x, ent.@y));
				}
				for each(ent in worldXML.Entities.FinalBoss)
				{
					add(new FinalBoss(ent.@x, ent.@y));
				}
				for each(ent in worldXML.Entities.HL3)
				{
					add(new HL3(ent.@x, ent.@y));
				}				
				for each(ent in worldXML.Entities.Cat)
				{
					add(new Cat(ent.@x, ent.@y));
				}	
				for each(ent in worldXML.Entities.Detector)
				{
					add(new Detector(ent.@x, ent.@y));
				}	
				
				for each(ent in worldXML.Entities.HeartPickup)
				{
					add(new HeartPickup(ent.@x, ent.@y));
				}
				for each(ent in worldXML.Entities.HorzDoor)
				{
					add(new HorzDoor(this, ent.@x, ent.@y,0));
				}
				for each(ent in worldXML.Entities.VertDoor)
				{
					add(new VertDoor(this, ent.@x, ent.@y,0));
				}
				for each(ent in worldXML.Entities.HorzDoorRed)
				{
					add(new HorzDoor(this, ent.@x, ent.@y,1));
				}
				for each(ent in worldXML.Entities.VertDoorRed)
				{
					add(new VertDoor(this, ent.@x, ent.@y,1));
				}
				for each(ent in worldXML.Entities.HorzDoorGreen)
				{
					add(new HorzDoor(this, ent.@x, ent.@y,2));
				}
				for each(ent in worldXML.Entities.VertDoorGreen)
				{
					add(new VertDoor(this, ent.@x, ent.@y,2));
				}
				for each(ent in worldXML.Entities.HorzDoorBlue)
				{
					add(new HorzDoor(this, ent.@x, ent.@y,3));
				}
				for each(ent in worldXML.Entities.VertDoorBlue)
				{
					add(new VertDoor(this, ent.@x, ent.@y,3));
				}
				for each(ent in worldXML.Entities.Key)
				{
					add(new GoldenKey(ent.@x, ent.@y,0));
				}
				for each(ent in worldXML.Entities.KeyRed)
				{
					add(new GoldenKey(ent.@x, ent.@y,1));
				}
				for each(ent in worldXML.Entities.KeyGreen)
				{
					add(new GoldenKey(ent.@x, ent.@y,2));
				}
				for each(ent in worldXML.Entities.KeyBlue)
				{
					add(new GoldenKey(ent.@x, ent.@y,3));
				}
				for each(ent in worldXML.Entities.RedEnemy)
				{
					add(new RedEnemy(ent.@x, ent.@y));
				}
				for each(ent in worldXML.Entities.StairsUp)
				{
					add(new StairsUp(ent.@x, ent.@y, ent.@file));
				}
				for each(ent in worldXML.Entities.StairsDown)
				{
					add(new StairsDown(ent.@x, ent.@y, ent.@file));
				}
				for each(ent in worldXML.Entities.Totem)
				{
					add(new Totem(ent.@x, ent.@y, ent.@Message));
					collisionGrid.setCell(ent.@x/48, ent.@y/48, true);
				}
			}
			
			if (worldXML.Tiles)
			{
				//trace("hello?");
				var tile:XML;
				for each(tile in worldXML.Tiles.tile)
				{
					//trace("tile x: "+tile.@x+" y: "+tile.@y+" tx: "+tile.@tx+" ty: "+tile.@ty);
					if (tile.@ty == 0) // top row
					{
						if (tile.@tx == 0) // brick
						{
							//trace("rock");
							addGraphic(new Image(Resource.brick), 100, 48 * tile.@x, 48 * tile.@y);
							collisionGrid.setCell(tile.@x, tile.@y, true);
						}
						if (tile.@tx == 1) // stone
						{
							//trace("rock");
							addGraphic(new Image(Resource.stone), 100, 48 * tile.@x, 48 * tile.@y);
							collisionGrid.setCell(tile.@x, tile.@y, true);
						}
						if (tile.@tx == 2) // rock
						{
							//trace("rock");
							addGraphic(new Image(Resource.rock), 100, 48 * tile.@x, 48 * tile.@y);
							collisionGrid.setCell(tile.@x, tile.@y, true);
						}
					}
				}
			}
		}
		
		override public function begin():void
		{
			super.begin();
			if (typeCount("finalboss") == 0 && typeCount("boss") == 0)
			{
				if (!Game.backgroundMusic.playing)
					Game.backgroundMusic.loop(Game.soundOn?1:0);			
			}
			else if (typeCount("finalboss") > 0)
			{
				Game.backgroundMusic.stop();
				Game.bossMusic.stop();
				Game.finalBossMusic.stop();
				if (!Game.finalBossMusic.playing)
					Game.finalBossMusic.loop(Game.soundOn?1:0);					
			}
			else if (typeCount("boss") > 0)
			{
				Game.backgroundMusic.stop();
				Game.bossMusic.stop();
				Game.finalBossMusic.stop();
				if (!Game.bossMusic.playing)
					Game.bossMusic.loop(Game.soundOn?1:0);					
			}
			
			if (typeCount("beeferton") == 0)
				myBeefy = add(new Beeferton(0, 0)) as Beeferton;
			
			
			if (Game.beefX != -5000 && Game.beefY != -5000)
			{
				myBeefy.x = Game.beefX;
				myBeefy.y = Game.beefY;
			}
			
			
			
			var cameraXpoint:int = Math.floor((myBeefy.x / 48) / 16);
			var cameraYpoint:int = Math.floor(((myBeefy.y) / 48) / 10);
			targetViewX = 48 * 16 * cameraXpoint;
			targetViewY = 48 * 10 * cameraYpoint;
			FP.camera.x = targetViewX;
			FP.camera.y = targetViewY - Game.HUDHEIGHT;
		}
		
		public function getGrid(x:Number, y:Number):Boolean
		{
			return collisionGrid.getCell(x, y);
		}
		
		public function setGrid(x:Number, y:Number, s:Boolean):void
		{
			collisionGrid.setCell(x, y, s);
		}
		
		override public function end():void
		{
			super.end();
			Game.stopAllBullets();
		}
		
		override public function update():void
		{
			//super.update();
			var cameraXpoint:int = Math.floor((myBeefy.x / 48) / 16);
			var cameraYpoint:int = Math.floor(((myBeefy.y) / 48) / 10);
			var change:Boolean = false;
			if (cameraXpoint != lastViewX)
			{
				change = true;
				targetViewX = 48 * 16 * cameraXpoint;
			}
			if (cameraYpoint != lastViewY)
			{
				change = true;
				targetViewY = 48 * 10 * cameraYpoint;
			}
			if (change)
				prepareRoom(cameraXpoint, cameraYpoint);
			var moving:Boolean = false;
			if (FP.camera.x != targetViewX)
			{
				moving = true;
				if (targetViewX < FP.camera.x)
					FP.camera.x -= 48;
				if (targetViewX > FP.camera.x)
					FP.camera.x += 48;		
			}
			if (FP.camera.y+Game.HUDHEIGHT != targetViewY)
			{
				moving = true;
				if (targetViewY < FP.camera.y+Game.HUDHEIGHT)
					FP.camera.y -= 48;
				if (targetViewY > FP.camera.y+Game.HUDHEIGHT)
					FP.camera.y += 48;
				if (Math.abs(targetViewY - (FP.camera.y + Game.HUDHEIGHT)) < 96)
					FP.camera.y = targetViewY - Game.HUDHEIGHT;
			}
			if (!moving)
				super.update();
			lastViewX = cameraXpoint;
			lastViewY = cameraYpoint;
			Game.beefX = myBeefy.x;
			Game.beefY = myBeefy.y;
		}
		
		public function prepareRoom(x:int, y:int):void
		{
			trace("prepareRoom(" + x + "," + y + ")");
		}
		
		private function getBG(x:Number, y:Number):int
		{
			if (x < 0 || x > bgGrid.length)
				return 0;
			if (y < 0 || y > bgGrid[x].length)
				return 0;
			return bgGrid[x][y];
		}
		
		override public function render():void
		{
			var xx:Number = Math.floor(FP.camera.x / 768);
			var yy:Number = Math.floor((FP.camera.y + Game.HUDHEIGHT) / 480);
			for (var i = -1; i <= 1; i++)
				for (var j = -1; j <= 1; j++)
				{
					FP.point.x = (xx+i) * 768;
					FP.point.y = (yy+j) * 480;// + HUDHEIGHT;
					if (getBG(xx+i, yy+j) == 0)
						Game.floor_rock.render(FP.point, FP.camera);
					if (getBG(xx+i, yy+j) == 1)
						Game.floor_grass.render(FP.point, FP.camera);
					if (getBG(xx+i, yy+j) == 2)
						Game.floor_wood.render(FP.point, FP.camera);
				}
			//floor_rock.render(, FP.camera);
			super.render();
			var t:Totem = null;
			if (Input.mouseY > Game.HUDHEIGHT)
			{
				FP.entity.x = FP.camera.x + Input.mouseX;
				FP.entity.y = FP.camera.y + Input.mouseY;
				FP.entity.setHitbox(1, 1);
				t = FP.entity.collide("totem", FP.entity.x, FP.entity.y) as Totem;
			}
			if (t)
			{
				Game.hud_totem.render(FP.zero, FP.zero);
				Game.draw_text(true, t.message, 24, 0, 0x000000);
			}
			else
			{	
			
				Game.drawHUD()
			}
			FP.point.x = Input.mouseX;
			FP.point.y = Input.mouseY;
			Game.reticle.render(FP.point, FP.zero);
		}
		
	}

}