package  
{
	import flash.geom.Rectangle;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.masks.Pixelmask;
	import net.flashpunk.Sfx;
	/**
	 * ...
	 * @author Wade McGillis
	 */
	public class LaserBeam extends WadeEntity
	{
		
		private var dx:Number;
		private var dy:Number;
		private var sndId:int;
		public function LaserBeam(xx:Number,yy:Number,ang:Number) 
		{
			x = xx;
			y = yy;
			dx = Math.cos(ang*FP.RAD);
			dy = Math.sin(ang*FP.RAD);
			var i:Image = new Image(Resource.laserbeam);
			i.centerOO();
			i.angle = ang;// * FP.DEG;
			graphic = i;
			type = "laserbeam";
			setHitbox(12, 12, 18, 18);
			sndId = Game.playBullet();
		}
		
		override public function update():void
		{
			super.update();
			if (offScreen())
			{
				FP.world.remove(this);
				x = -5000;
				y = -5000;
				return;
			}
			x += 16 * dx;
			y += 16 * dy;
			if (collideTerrain(x, y))
				FP.world.remove(this);
		}
		
		override public function removed():void
		{
			if (sndId != -1)
				Game.stopBullet(sndId);
		}
		
	}

}