package  
{
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.World;
	/**
	 * ...
	 * @author Wade McGillis
	 */
	public class Options extends World
	{
		private var up:Button;
		private var left:Button;
		private var down:Button;
		private var right:Button;
		private var action:Button;
		private var current:Button;
		public function Options() 
		{
			addGraphic(new Image(Resource.title));
			add(new Button(toggleSound, 384, 120 - 80, Game.soundOn?"Turn sound off":"Turn sound on", 0x222288, 0xFFFFFF)) as Button;
			up = add(new Button(upActive, 384, 120, "Up : "+Key.name(Game.KEY_MOVEUP), 0x222288, 0xFFFFFF)) as Button;
			left = add(new Button(leftActive, 384, 120+80, "Left : "+Key.name(Game.KEY_MOVELEFT), 0x222288, 0xFFFFFF)) as Button;
			down = add(new Button(downActive, 384, 120+80+80, "Down : " + Key.name(Game.KEY_MOVEDOWN), 0x222288, 0xFFFFFF)) as Button;
			right = add(new Button(rightActive, 384, 120+80+80+80, "Right : " + Key.name(Game.KEY_MOVERIGHT), 0x222288, 0xFFFFFF)) as Button;
			action = add(new Button(actionActive, 384, 120 + 80 + 80 + 80 + 80, "Action : " + Key.name(Game.KEY_MOVEACTION), 0x222288, 0xFFFFFF)) as Button;
			add(new Button(goBack, 384, 120 + 80 + 80 + 80 + 80 + 80, "< Back", 0x228822, 0xFFFFFF)) as Button;
			current = null;
		}
		
		public function goBack():void
		{
			FP.world = new Title();
		}
		
		public function toggleSound():void
		{
			Game.soundOn = !Game.soundOn;
						addGraphic(new Image(Resource.title));
					
					add(new Button(toggleSound, 384, 120-80, Game.soundOn?"Turn sound off":"Turn sound on", 0x222288, 0xFFFFFF)) as Button;
					up = add(new Button(upActive, 384, 120, "Up : "+Key.name(Game.KEY_MOVEUP), 0x222288, 0xFFFFFF)) as Button;
					left = add(new Button(leftActive, 384, 120+80, "Left : "+Key.name(Game.KEY_MOVELEFT), 0x222288, 0xFFFFFF)) as Button;
					down = add(new Button(downActive, 384, 120+80+80, "Down : " + Key.name(Game.KEY_MOVEDOWN), 0x222288, 0xFFFFFF)) as Button;
					right = add(new Button(rightActive, 384, 120+80+80+80, "Right : " + Key.name(Game.KEY_MOVERIGHT), 0x222288, 0xFFFFFF)) as Button;
					action = add(new Button(actionActive, 384, 120 + 80 + 80 + 80 + 80, "Action : " + Key.name(Game.KEY_MOVEACTION), 0x222288, 0xFFFFFF)) as Button;
					add(new Button(goBack, 384, 120 + 80 + 80 + 80 + 80 + 80, "< Back", 0x228822, 0xFFFFFF)) as Button;
		}
		
		public function upActive():void
		{
			up.setForced(false);
			left.setForced(false);
			down.setForced(false);
			right.setForced(false);
			action.setForced(false);
			
			current = up;
			current.setForced(true);
			Input.lastKey = 0;
		}
		
		public function leftActive():void
		{
			up.setForced(false);
			left.setForced(false);
			down.setForced(false);
			right.setForced(false);
			action.setForced(false);
			
			current = left;
			current.setForced(true);
			Input.lastKey = 0;
		}
		
		public function downActive():void
		{
			up.setForced(false);
			left.setForced(false);
			down.setForced(false);
			right.setForced(false);
			action.setForced(false);
			
			current = down;
			current.setForced(true);
			Input.lastKey = 0;
		}
	
		public function rightActive():void
		{
			up.setForced(false);
			left.setForced(false);
			down.setForced(false);
			right.setForced(false);
			action.setForced(false);
			
			current = right;
			current.setForced(true);
			Input.lastKey = 0;
		}
		
		public function actionActive():void
		{
			up.setForced(false);
			left.setForced(false);
			down.setForced(false);
			right.setForced(false);
			action.setForced(false);
			
			current = action;
			current.setForced(true);
			Input.lastKey = 0;
		}
		
		override public function update():void
		{
			super.update();
			if (current != null)
				if (Input.lastKey != 0)
				{
					if (current == up)
						Game.KEY_MOVEUP = Input.lastKey;
					if (current == left)
						Game.KEY_MOVELEFT = Input.lastKey;
					if (current == down)
						Game.KEY_MOVEDOWN = Input.lastKey;
					if (current == right)
						Game.KEY_MOVERIGHT = Input.lastKey;
					if (current == action)
						Game.KEY_MOVEACTION = Input.lastKey;
					current = null;

					removeAll();
					addGraphic(new Image(Resource.title));
					
					add(new Button(toggleSound, 384, 120-80, Game.soundOn?"Turn sound off":"Turn sound on", 0x222288, 0xFFFFFF)) as Button;
					up = add(new Button(upActive, 384, 120, "Up : "+Key.name(Game.KEY_MOVEUP), 0x222288, 0xFFFFFF)) as Button;
					left = add(new Button(leftActive, 384, 120+80, "Left : "+Key.name(Game.KEY_MOVELEFT), 0x222288, 0xFFFFFF)) as Button;
					down = add(new Button(downActive, 384, 120+80+80, "Down : " + Key.name(Game.KEY_MOVEDOWN), 0x222288, 0xFFFFFF)) as Button;
					right = add(new Button(rightActive, 384, 120+80+80+80, "Right : " + Key.name(Game.KEY_MOVERIGHT), 0x222288, 0xFFFFFF)) as Button;
					action = add(new Button(actionActive, 384, 120 + 80 + 80 + 80 + 80, "Action : " + Key.name(Game.KEY_MOVEACTION), 0x222288, 0xFFFFFF)) as Button;
					add(new Button(goBack, 384, 120 + 80 + 80 + 80 + 80 + 80, "< Back", 0x228822, 0xFFFFFF)) as Button;

					up.setForced(false);
					left.setForced(false);
					down.setForced(false);
					right.setForced(false);
					action.setForced(false);
					
				}
		}
		
	}

}