package  
{
	import net.flashpunk.FP;
	import net.flashpunk.Graphic;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.Sfx;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.World;
	/**
	 * ...
	 * @author Wade McGillis
	 */
	public class Story extends World
	{
		
		private var flashTimer:int;
		private var flashing:Boolean;
		
		private var sprBG:Image;
		private var sprBGFlash:Image;
		private var sprLady:Image;
		private var sprBeefy:Image;
		private var sprLadyZap:Image;
		private var sprBeefyZap:Image;
		private var sprNewspaper:Image;
		private var ladyX:int;
		private var beefyX:int;
		
		private var mode:int;
		
		public function Story() 
		{
			flashTimer = -500;
			mode = 0;
			sprBG = new Image(Resource.story_mooperture);
			sprBGFlash = new Image(Resource.story_mooperture_lazor);
			sprLady = new Image(Resource.story_ladycow);
			sprBeefy = new Image(Resource.story_beeferton);
			sprLadyZap = new Image(Resource.story_ladycow_zap);
			sprBeefyZap = new Image(Resource.story_beeferton_zap);
			sprNewspaper = new Image(Resource.story);
			
			sprLady.originX = 64;
			sprLady.originY = 176;
			sprLadyZap.originX = 64;
			sprLadyZap.originY = 176;
			
			sprBeefy.originX = 64;
			sprBeefy.originY = 176;
			sprBeefyZap.originX = 64;
			sprBeefyZap.originY = 176;
			
			ladyX = 128;
			beefyX = 628;
		}
		
		override public function update():void
		{
			super.update();
			flashTimer--;
			if (flashTimer == 0)
			{
				flashTimer = 10;
				flashing = !flashing;
			}
			if ((Input.pressed(Key.ANY) || Input.mousePressed))
			{
				var change:Boolean = true;
				if (mode == 1)
				{
					if (ladyX < 768 / 2 - 32)
						change = false;
				}
				if (mode == 4)
				{
					if (beefyX > 768 / 2 + 32)
						change = false;
				}
				if (change)
				{
					mode++;
					flashing = false;
					flashTimer = -100;
				if (mode == 5 || mode == 2)
					new Sfx(Resource.snd_shrink).play(Game.soundOn?1:0);
				}
			}
			if (mode == 1)
			{
				ladyX += 4;
				if (ladyX > 768 / 2 - 32)
				{
					ladyX = 768 / 2 - 32;
					flashTimer = 1;
				}
			}
			if (mode == 2)
			{
				sprLady.scale *= .8;
				if (sprLady.scale < .01)
					sprLady.scale = 0;
			}
			if (mode == 4)
			{
				beefyX -= 4;
				if (beefyX < 768 / 2 + 32)
				{
					beefyX = 768 / 2 + 32;
					flashTimer = 1;
				}
			}
			if (mode == 5)
			{
				sprBeefy.scale *= .8;
				if (sprBeefy.scale < .01)
					sprBeefy.scale = 0;				
			}
			if (mode == 6)
				FP.world = new Trippy();
		}
		
		override public function render():void
		{
			super.render();
			if (mode == 0 || mode == 1 || mode == 2)
			{
				
				if (flashing)
				{
					draw_sprite(sprBGFlash, 0, 0);
					draw_sprite(sprLadyZap, ladyX, 432);
				}
				else
				{
					draw_sprite(sprBG, 0, 0);
					draw_sprite(sprLady, ladyX, 432);
				}
				draw_sprite(sprBeefy, beefyX, 432);
			}
			if (mode == 3)
			{
				draw_sprite(sprNewspaper, 0, 0);
				return;
			}
			if (mode == 4 || mode == 5)
			{
				if (flashing)
				{
					draw_sprite(sprBGFlash, 0, 0);
					draw_sprite(sprBeefyZap, beefyX, 432);
				}
				else
				{
					draw_sprite(sprBG, 0, 0);
					draw_sprite(sprBeefy, beefyX, 432);
				}
			}
				
		}
		
		
		private function draw_sprite(spr:Graphic, x:Number, y:Number):void
		{
			FP.point.x = x;
			FP.point.y = Game.HUDHEIGHT+y;
			spr.render(FP.point, FP.zero);
		}
	}

}