package  
{
	import net.flashpunk.FP;
	import net.flashpunk.Graphic;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.Sfx;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.World;
	
	/**
	 * ...
	 * @author Wade McGillis
	 */
	public class Trippy extends World
	{
		
		
		private var sprAtom:Image;
		private var sprGalaxy:Image;
		private var sprPlanet:Image;
		private var sprBeefy:Image;
		
		
		public function Trippy() 
		{
			new Sfx(Resource.snd_fall).play(Game.soundOn?1:0);
			sprAtom = new Image(Resource.atom);
			sprGalaxy = new Image(Resource.galaxy);
			sprPlanet = new Image(Resource.planet);
			sprBeefy = new Image(Resource.story_beeferton);
			
			sprAtom.originX = 160;
			sprAtom.originY = 160;
			
			sprGalaxy.originX = 160;
			sprGalaxy.originY = 160;
			
			sprPlanet.originX = 160;
			sprPlanet.originY = 160;
			
			sprBeefy.originX = 64;
			sprBeefy.originY = 96;
			
			sprAtom.scale = .1;
			sprGalaxy.scale = .01;
			sprPlanet.scale = .01;
		}
		
		override public function update():void
		{
			super.update();
			sprBeefy.angle += 10;
			sprAtom.scale *= 1.05;
			if (sprAtom.scale > 4)
				sprGalaxy.scale *= 1.05;
			if (sprGalaxy.scale > 4)
				sprPlanet.scale *= 1.05;	
			if (sprPlanet.scale > 50)
				Game.switchToLevel(0);
			if (sprAtom.scale > 45)
				sprAtom.scale = 45;
			if (sprGalaxy.scale > 45)
				sprGalaxy.scale = 45;
			//if (sprPlanet.scale > 10)
			//	sprPlanet.scale = 10;
		}
		
		override public function render():void
		{
			super.render();
			draw_sprite(sprAtom, 384, 320);
			draw_sprite(sprGalaxy, 384, 320);
			draw_sprite(sprPlanet, 384, 320);
			draw_sprite(sprBeefy, 384, 320);
			
		}
		
		private function draw_sprite(spr:Graphic, x:Number, y:Number)
		{
			FP.point.x = x;
			FP.point.y = y;
			spr.render(FP.point, FP.zero);
		}
		
	}

}