package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import flash.geom.Rectangle;
	/**
	 * ...
	 * @author Wade McGillis
	 */
	public class WadeEntity extends Entity
	{
		
		public function offScreen():Boolean
		{
			if (!onCamera)
				return true;
			if (y < FP.camera.y + Game.HUDHEIGHT)
				return true;
			return false;
		}
		
		protected function collideTerrain(xx:Number, yy:Number):Boolean
		{
			var w:GameLevel = FP.world as GameLevel;
			var tx:int = xx / 48;
			var ty:int = yy / 48;
			for (var i:int = -2; i <= 2; i++)
				for (var j:int = -2; j <= 2; j++)
				{
					if (w.getGrid(tx + i, ty + j))
					{
						if (flashpunkHasCrapCollisions(xx, yy, 48 * (tx + i), 48 * (ty + j), 48, 48))
							return true;
					}
				}
			return false;
		}
		
		protected function flashpunkHasCrapCollisions(xx:Number, yy:Number, ox:Number, oy:Number, ww:Number, hh:Number):Boolean
		{
			var r1:Rectangle = new Rectangle(xx, yy, width, height);
			var r2:Rectangle = new Rectangle(ox, oy, ww, hh);
			return r1.intersects(r2);
		}
		
	}

}